package com.gic.haoban.manage.web.handle;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.gic.api.base.commons.Page;
import com.gic.commons.util.DataApiUtils;
import com.gic.enterprise.api.dto.security.DownloadReportDTO;
import com.gic.haoban.manage.web.utils.data.StoreAuthUtils;
import com.gic.haoban.manage.web.vo.wechatwork.WechatWorkLostClerkVO;
import com.gic.web.common.download.DownloadHandlerAbstract;
import com.gic.web.common.download.context.Context;
import org.apache.commons.collections.CollectionUtils;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.*;

/**
 * 数据-企微数据-流失好友-导购
 */
@Component
public class WechatWorkLostClerkHandle extends DownloadHandlerAbstract<WechatWorkLostClerkVO> {

    private static final Logger LOGGER = LogManager.getLogger(WechatWorkLostClerkHandle.class);

    @Autowired
    private StoreAuthUtils storeAuthUtils;

    @Override
    public List<WechatWorkLostClerkVO> getData(Context context, String searchDataParams, Integer currentPage) {
        boolean isFirst = currentPage != null && currentPage == 1;
        if (isFirst) {
            LOGGER.info("数据-企微数据-流失好友-导购导出日志");
        }
        JSONObject jsonObject = JSON.parseObject(searchDataParams);
        jsonObject.put("pageNum", currentPage);
        jsonObject.put("pageSize", getPageSize());
        Map<String, Object> res = DataApiUtils.http(jsonObject.toJSONString(), "data_mbr_scale_haoban_background_loss_statisti");
        List<JSONObject> list = DataApiUtils.getPageList(res);

        jsonObject.put("groupType", 1);
        jsonObject.put("storeGroup", 8);

        if (list == null) {
            list = new ArrayList<>();
        }
        if (isFirst) {
            Map<String, Object> totalRes = DataApiUtils.http(jsonObject.toJSONString(), "data_mbr_scale_haoban_background_loss_statisti");
            Page page = DataApiUtils.getPageData(totalRes);
            if (page != null) {
                List<JSONObject> totalList = page.getResult();
                if (CollectionUtils.isNotEmpty(totalList)) {
                    JSONObject total = totalList.get(0);
                    total.put("clerkName", "合计（" + page.getTotalCount() + "）");
                    list.add(0, total);
                }
            }
        }

        if (CollectionUtils.isNotEmpty(list)) {
            List<WechatWorkLostClerkVO> result = JSONObject.parseArray(JSON.toJSONString(list), WechatWorkLostClerkVO.class);
            return result;
        }
        return Collections.EMPTY_LIST;
    }

    @Override
    public List<String> getColumnNames() {
        return Collections.EMPTY_LIST;
    }

    @Override
    public List<String> getColumnNames(Context context){
        DownloadReportDTO downloadReportDTO = context.getDownloadReportDTO();
        String searchDataParams = downloadReportDTO.getSearchDataParams();
        JSONObject jsonObject = JSONObject.parseObject(searchDataParams);
        List<String> list = (List<String>) jsonObject.get("indexList");
        return list;
    }

    @Override
    public LinkedHashMap<String, List<String>> doubleColumnNames() {
        return null;
    }

    @Override
    public List<String> getColumns() {
        return Collections.EMPTY_LIST;
    }

    @Override
    public List<String> getColumns(Context context) {
        DownloadReportDTO downloadReportDTO = context.getDownloadReportDTO();
        String searchDataParams = downloadReportDTO.getSearchDataParams();
        JSONObject jsonObject = JSONObject.parseObject(searchDataParams);
        List<String> list = (List<String>) jsonObject.get("fieldList");
        return list;
    }
}
